]> git.ipfire.org Git - people/ms/u-boot.git/blame - MAKEALL
serial: sh: Add support External Clock mode
[people/ms/u-boot.git] / MAKEALL
CommitLineData
f2352877 1#!/bin/bash
0777eafb
WD
2# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
eca3aeb3
WD
5#
6# SPDX-License-Identifier: GPL-2.0+
0777eafb 7
d8e392d9
MF
8usage()
9{
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
4d1584bd 21 -b BOARD, --board BOARD Build all boards with board name BOARD
7f79c6f2 22 -l, --list List all targets to be built
9b96c6b1
MV
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
33f336d5 25 -C, --check Enable build checking
08510204
JH
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
d8e392d9
MF
28 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
47104c37 41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
93e14596
WD
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
d8e392d9
MF
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
f588bb03 46 BUILD_NBUILDS number of parallel targets (default: 1)
d8e392d9
MF
47
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61}
62
4d1584bd
MY
63SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
0777eafb
WD
65
66# Option processing based on util-linux-2.13/getopt-parse.bash
67
071bc923 68# Note that we use `"$@"' to let each command-line parameter expand to a
0777eafb
WD
69# separate word. The quotes around `$@' are essential!
70# We need TEMP as the `eval set --' would nuke the return value of
71# getopt.
72TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
d8e392d9 75[ $? != 0 ] && usage 1
0777eafb
WD
76
77# Note the quotes around `$TEMP': they are essential!
78eval set -- "$TEMP"
79
80SELECTED=''
7f79c6f2 81ONLY_LIST=''
9b96c6b1
MV
82PRINT_MAINTS=''
83MAINTAINERS_ONLY=''
08510204
JH
84CONTINUE=''
85REBUILD_ERRORS=''
0777eafb
WD
86
87while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
aa2e279d 101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
0777eafb 102 else
aa2e279d 103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
0777eafb
WD
104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
27af930e 110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
0777eafb 111 else
27af930e 112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
0777eafb
WD
113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
4d1584bd
MY
125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
33f336d5
KP
136 -C|--check)
137 CHECK='C=1'
138 shift ;;
08510204
JH
139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
7f79c6f2
MV
145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
9b96c6b1
MV
148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
d8e392d9
MF
157 -h|--help)
158 usage ;;
0777eafb
WD
159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164done
e18fd940
MY
165
166GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
168 exit 1
169}
170
0777eafb
WD
171# echo "Remaining arguments:"
172# for arg do echo '--> '"\`$arg'" ; done
173
bb6da87d
MY
174if [ ! -r boards.cfg ]; then
175 echo "Could not find boards.cfg"
176 tools/genboardscfg.py || {
177 echo "Failed to generate boards.cfg" >&2
178 exit 1
179 }
180fi
181
0777eafb
WD
182FILTER="\$1 !~ /^#/"
183[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
184[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
185[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
186[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
4d1584bd 187[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
0777eafb
WD
188
189if [ "$SELECTED" ] ; then
27af930e 190 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
cd57b0bb
PT
191
192 # Make sure some boards from boards.cfg are actually found
193 if [ -z "$SELECTED" ] ; then
194 echo "Error: No boards selected, invalid arguments"
195 exit 1
196 fi
0777eafb
WD
197fi
198
199#########################################################################
200
40a28f08
PT
201# Print statistics when we exit
202trap exit 1 2 3 15
203trap print_stats 0
204
7fa6a2f3
WD
205# Determine number of CPU cores if no default was set
206: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
207
208if [ "$BUILD_NCPUS" -gt 1 ]
209then
55f786d8 210 JOBS="-j $((BUILD_NCPUS + 1))"
7fa6a2f3
WD
211else
212 JOBS=""
213fi
214
f9328639
MB
215if [ "${MAKEALL_LOGDIR}" ] ; then
216 LOG_DIR=${MAKEALL_LOGDIR}
217else
218 LOG_DIR="LOG"
219fi
887e2ec9 220
f588bb03
AF
221: ${BUILD_NBUILDS:=1}
222BUILD_MANY=0
223
224if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
225 BUILD_MANY=1
226 : ${BUILD_DIR:=./build}
227 mkdir -p "${BUILD_DIR}/ERR"
228 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
f9328639
MB
229fi
230
f588bb03
AF
231: ${BUILD_DIR:=.}
232
233OUTPUT_PREFIX="${BUILD_DIR}"
234
235[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
08510204
JH
236if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
237 find "${LOG_DIR}/" -type f -exec rm -f {} +
238fi
7ebf7443
WD
239
240LIST=""
241
40a28f08
PT
242# Keep track of the number of builds and errors
243ERR_CNT=0
244ERR_LIST=""
b86a475c
JH
245WRN_CNT=0
246WRN_LIST=""
40a28f08 247TOTAL_CNT=0
08510204 248SKIP_CNT=0
f588bb03
AF
249CURRENT_CNT=0
250OLDEST_IDX=1
f2352877 251RC=0
40a28f08 252
9ec49f8f 253# Helper funcs for parsing boards.cfg
8948794a 254targets_by_field()
9ec49f8f 255{
8e5a2d42
MY
256 field=$1
257 regexp=$2
258
259 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
260 boards.cfg
9ec49f8f 261}
8e5a2d42 262
8948794a
MY
263targets_by_arch() { targets_by_field 2 "$@" ; }
264targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
265targets_by_soc() { targets_by_field 4 "$@" ; }
9ec49f8f 266
0db5bca8
WD
267#########################################################################
268## MPC5xx Systems
269#########################################################################
270
8948794a 271LIST_5xx="$(targets_by_cpu mpc5xx)"
0db5bca8 272
945af8d7
WD
273#########################################################################
274## MPC5xxx Systems
275#########################################################################
276
8948794a 277LIST_5xxx="$(targets_by_cpu mpc5xxx)"
945af8d7 278
8993e54b
RJ
279#########################################################################
280## MPC512x Systems
281#########################################################################
282
8948794a 283LIST_512x="$(targets_by_cpu mpc512x)"
945af8d7 284
7ebf7443
WD
285#########################################################################
286## MPC8xx Systems
287#########################################################################
9ec49f8f 288
8948794a 289LIST_8xx="$(targets_by_cpu mpc8xx)"
7ebf7443
WD
290
291#########################################################################
292## PPC4xx Systems
293#########################################################################
294
8948794a 295LIST_4xx="$(targets_by_cpu ppc4xx)"
7ebf7443
WD
296
297#########################################################################
298## MPC824x Systems
299#########################################################################
300
8948794a 301LIST_824x="$(targets_by_cpu mpc824x)"
592c5cab 302
7ebf7443 303#########################################################################
7aa78614 304## MPC8260 Systems (includes 8250, 8255 etc.)
7ebf7443
WD
305#########################################################################
306
8948794a 307LIST_8260="$(targets_by_cpu mpc8260)"
7ebf7443 308
f046ccd1
EL
309#########################################################################
310## MPC83xx Systems (includes 8349, etc.)
311#########################################################################
312
8948794a 313LIST_83xx="$(targets_by_cpu mpc83xx)"
f046ccd1 314
42d1f039
WD
315#########################################################################
316## MPC85xx Systems (includes 8540, 8560 etc.)
317#########################################################################
318
8948794a 319LIST_85xx="$(targets_by_cpu mpc85xx)"
42d1f039 320
822d5536
JL
321#########################################################################
322## MPC86xx Systems
323#########################################################################
324
8948794a 325LIST_86xx="$(targets_by_cpu mpc86xx)"
822d5536 326
7ebf7443
WD
327#########################################################################
328## 74xx/7xx Systems
329#########################################################################
330
8948794a 331LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
7ebf7443 332
d9a42c0a
WD
333#########################################################################
334## PowerPC groups
335#########################################################################
336
337LIST_TSEC=" \
338 ${LIST_83xx} \
339 ${LIST_85xx} \
340 ${LIST_86xx} \
341"
342
a47a12be 343LIST_powerpc=" \
fb56579f 344 ${LIST_5xx} \
3deca9d4 345 ${LIST_512x} \
fb56579f
KP
346 ${LIST_5xxx} \
347 ${LIST_8xx} \
fb56579f
KP
348 ${LIST_824x} \
349 ${LIST_8260} \
350 ${LIST_83xx} \
351 ${LIST_85xx} \
352 ${LIST_86xx} \
353 ${LIST_4xx} \
2ae18241 354 ${LIST_74xx_7xx}\
fb56579f 355"
7ebf7443 356
a47a12be
SR
357# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
358# still using "ppc" instead of "powerpc"
359LIST_ppc=" \
360 ${LIST_powerpc} \
361"
362
7ebf7443
WD
363#########################################################################
364## StrongARM Systems
365#########################################################################
366
8948794a 367LIST_SA="$(targets_by_cpu sa1100)"
7ebf7443 368
cce5d210
AM
369#########################################################################
370## ARM7 Systems
371#########################################################################
372
8948794a 373LIST_ARM7="$(targets_by_cpu arm720t)"
cce5d210 374
7ebf7443
WD
375#########################################################################
376## ARM9 Systems
377#########################################################################
378
8948794a
MY
379LIST_ARM9="$(targets_by_cpu arm920t) \
380 $(targets_by_cpu arm926ejs) \
381 $(targets_by_cpu arm946es) \
6f21347d 382"
7ebf7443 383
8ed96046
WD
384#########################################################################
385## ARM11 Systems
386#########################################################################
8948794a
MY
387LIST_ARM11="$(targets_by_cpu arm1136) \
388 $(targets_by_cpu arm1176) \
cce5d210 389"
8ed96046 390
f904cdbb 391#########################################################################
f56348af 392## ARMV7 Systems
f904cdbb 393#########################################################################
f37586bb 394
8948794a 395LIST_ARMV7="$(targets_by_cpu armv7)"
f904cdbb 396
2475e634
DF
397#########################################################################
398## ARMV8 Systems
399#########################################################################
400
401LIST_ARMV8="$(targets_by_cpu armv8)"
402
602cac13
JCPV
403#########################################################################
404## AT91 Systems
405#########################################################################
406
8948794a 407LIST_at91="$(targets_by_soc at91)"
602cac13 408
7ebf7443
WD
409#########################################################################
410## Xscale Systems
411#########################################################################
412
8948794a 413LIST_pxa="$(targets_by_cpu pxa)"
7ebf7443 414
24dede48
SR
415#########################################################################
416## SPEAr Systems
417#########################################################################
418
8948794a 419LIST_spear="$(targets_by_soc spear)"
24dede48 420
d9a42c0a
WD
421#########################################################################
422## ARM groups
423#########################################################################
2d5b561e 424
2475e634
DF
425LIST_arm="$(targets_by_arch arm | \
426 for ARMV8_TARGET in $LIST_ARMV8; \
427 do sed "/$ARMV8_TARGET/d"; \
428 done) \
429"
7ebf7443 430
c021880a 431#########################################################################
b62bdffb 432## MIPS Systems (default = big endian)
c021880a
WD
433#########################################################################
434
ed638b6a 435LIST_mips="$(targets_by_arch mips)"
c021880a 436
deddf5d2
SK
437#########################################################################
438## OpenRISC Systems
439#########################################################################
440
8948794a 441LIST_openrisc="$(targets_by_arch openrisc)"
b62bdffb 442
7a8e9bed 443#########################################################################
fea25720 444## x86 Systems
7a8e9bed
WD
445#########################################################################
446
8948794a 447LIST_x86="$(targets_by_arch x86)"
7a8e9bed 448
5c952cf0
WD
449#########################################################################
450## Nios-II Systems
451#########################################################################
452
8948794a 453LIST_nios2="$(targets_by_arch nios2)"
5c952cf0 454
857cad37
WD
455#########################################################################
456## MicroBlaze Systems
457#########################################################################
458
8948794a 459LIST_microblaze="$(targets_by_arch microblaze)"
857cad37 460
f8c3b4f3
ZL
461#########################################################################
462## ColdFire Systems
463#########################################################################
464
8948794a 465LIST_m68k="$(targets_by_arch m68k)"
c13f47b0 466LIST_coldfire=${LIST_m68k}
f8c3b4f3 467
6ccec449
WD
468#########################################################################
469## AVR32 Systems
470#########################################################################
471
8948794a 472LIST_avr32="$(targets_by_arch avr32)"
6ccec449 473
ef26a08f
AL
474#########################################################################
475## Blackfin Systems
476#########################################################################
477
8948794a 478LIST_blackfin="$(targets_by_arch blackfin)"
ef26a08f 479
c7144373
JCPV
480#########################################################################
481## SH Systems
482#########################################################################
483
8948794a
MY
484LIST_sh2="$(targets_by_cpu sh2)"
485LIST_sh3="$(targets_by_cpu sh3)"
486LIST_sh4="$(targets_by_cpu sh4)"
d9a42c0a 487
8948794a 488LIST_sh="$(targets_by_arch sh)"
c7144373 489
c2f02da2
DH
490#########################################################################
491## SPARC Systems
492#########################################################################
493
8948794a 494LIST_sparc="$(targets_by_arch sparc)"
7ebf7443 495
5f1719c1
ML
496#########################################################################
497## NDS32 Systems
498#########################################################################
499
8948794a 500LIST_nds32="$(targets_by_arch nds32)"
5f1719c1 501
568c1fad
AB
502#########################################################################
503## ARC Systems
504#########################################################################
505
506LIST_arc="$(targets_by_arch arc)"
507
7ebf7443
WD
508#-----------------------------------------------------------------------
509
9b96c6b1
MV
510get_target_location() {
511 local target=$1
512 local BOARD_NAME=""
513 local CONFIG_NAME=""
514 local board=""
515 local vendor=""
516
517 # Automatic mode
23d6410c 518 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
9b96c6b1
MV
519 if [ -z "${line}" ] ; then echo "" ; return ; fi
520
521 set ${line}
522
bb6da87d 523 CONFIG_NAME="${7%_defconfig}"
9b96c6b1 524
bb6da87d 525 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
9b96c6b1 526
27af930e
AA
527 if [ $# -gt 5 ]; then
528 if [ "$6" = "-" ] ; then
529 board=${BOARD_NAME}
530 else
531 board="$6"
532 fi
9b96c6b1
MV
533 fi
534
535 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
27af930e
AA
536 [ $# -gt 6 ] && [ "$8" != "-" ] && {
537 tmp="${8%:*}"
9b96c6b1
MV
538 if [ "$tmp" ] ; then
539 CONFIG_NAME="$tmp"
540 fi
541 }
542
543 # Assign board directory to BOARDIR variable
27af930e 544 if [ "${vendor}" == "-" ] ; then
9b96c6b1
MV
545 BOARDDIR=${board}
546 else
547 BOARDDIR=${vendor}/${board}
548 fi
549
27af930e 550 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
9b96c6b1
MV
551}
552
553get_target_maintainers() {
27af930e 554 local name=`echo $1 | cut -d : -f 3`
9b96c6b1 555
23d6410c 556 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
27af930e 557 if [ -z "${line}" ]; then
9b96c6b1
MV
558 echo ""
559 return ;
560 fi
561
27af930e
AA
562 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
563 [ "$mails" == "-" ] && mails=""
564 echo "$mails"
9b96c6b1
MV
565}
566
47104c37
AM
567get_target_arch() {
568 local target=$1
569
570 # Automatic mode
54d1f504 571 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
47104c37
AM
572
573 if [ -z "${line}" ] ; then echo "" ; return ; fi
574
575 set ${line}
576 echo "$2"
577}
578
9b96c6b1
MV
579list_target() {
580 if [ "$PRINT_MAINTS" != 'y' ] ; then
581 echo "$1"
582 return
583 fi
584
585 echo -n "$1:"
586
587 local loc=`get_target_location $1`
588
589 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
590
591 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
592
593 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
594
595 local dir=`echo ${loc} | cut -d ":" -f 2`
596 local cfg=`echo ${loc} | cut -d ":" -f 1`
597 local git_result=`git log --format=%aE board/${dir} \
598 include/configs/${cfg}.h | grep "@"`
599 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
600 head -n 3`
601 local git_result_top=`echo ${git_result} | tr " " "\n" | \
602 sort | uniq -c | sort -nr | head -n 3 | \
603 sed "s/^ \+[0-9]\+ \+//"`
604
605 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
606 sort -u | tr "\n" " " | sed "s/ $//" ;
607 else
608 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
609 sed "s/ $//" ;
610 fi
611
612 echo ""
613}
614
f588bb03
AF
615# Each finished build will have a file called ${donep}${n},
616# where n is the index of the build. Each build
617# we've already noted as finished will have ${skipp}${n}.
618# The code managing the build process will use this information
619# to ensure that only BUILD_NBUILDS builds are in flight at once
620donep="${LOG_DIR}/._done_"
621skipp="${LOG_DIR}/._skip_"
622
c97d59cb
JH
623build_target_killed() {
624 echo "Aborted $target build."
625 # Remove the logs for this board since it was aborted
626 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
627 exit
628}
629
7ebf7443
WD
630build_target() {
631 target=$1
f588bb03
AF
632 build_idx=$2
633
f50bf50d
AF
634 if [ "$ONLY_LIST" == 'y' ] ; then
635 list_target ${target}
636 return
637 fi
638
f588bb03
AF
639 if [ $BUILD_MANY == 1 ] ; then
640 output_dir="${OUTPUT_PREFIX}/${target}"
641 mkdir -p "${output_dir}"
c97d59cb 642 trap build_target_killed TERM
f588bb03
AF
643 else
644 output_dir="${OUTPUT_PREFIX}"
645 fi
646
47104c37 647 target_arch=$(get_target_arch ${target})
c17b94ec 648 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
47104c37 649 if [ "${cross_toolchain}" ] ; then
e18fd940 650 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
47104c37 651 elif [ "${CROSS_COMPILE}" ] ; then
e18fd940 652 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
47104c37 653 else
e18fd940 654 MAKE=$GNU_MAKE
47104c37
AM
655 fi
656
9e414032
MY
657 if [ "${output_dir}" != "." ] ; then
658 MAKE="${MAKE} O=${output_dir}"
659 fi
660
7ebf7443 661 ${MAKE} distclean >/dev/null
bb6da87d
MY
662
663 echo "Building ${target} board..."
664 ${MAKE} -s ${target}_defconfig >/dev/null
f9328639 665
33f336d5 666 ${MAKE} ${JOBS} ${CHECK} all \
f588bb03 667 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
f2352877
PT
668
669 # Check for 'make' errors
670 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
671 RC=1
672 fi
673
f588bb03 674 if [ $BUILD_MANY == 1 ] ; then
c97d59cb
JH
675 trap - TERM
676
7390643f 677 ${MAKE} -s clean
f588bb03
AF
678
679 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
b86a475c 680 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
f588bb03
AF
681 else
682 rm ${LOG_DIR}/${target}.ERR
683 fi
40a28f08 684 else
f588bb03 685 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
b86a475c
JH
686 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
687 : $(( ERR_CNT += 1 ))
688 ERR_LIST="${ERR_LIST} $target"
689 else
690 : $(( WRN_CNT += 1 ))
691 WRN_LIST="${WRN_LIST} $target"
692 fi
f588bb03
AF
693 else
694 rm ${LOG_DIR}/${target}.ERR
695 fi
40a28f08
PT
696 fi
697
f588bb03
AF
698 OBJS=${output_dir}/u-boot
699 if [ -e ${output_dir}/spl/u-boot-spl ]; then
700 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
0c185696
SW
701 fi
702
703 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
f588bb03
AF
704
705 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
706
f588bb03 707 touch "${donep}${build_idx}"
7ebf7443 708}
f588bb03
AF
709
710manage_builds() {
711 search_idx=${OLDEST_IDX}
f50bf50d
AF
712 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
713
f588bb03
AF
714 while true; do
715 if [ -e "${donep}${search_idx}" ] ; then
f588bb03
AF
716 : $(( CURRENT_CNT-- ))
717 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
718 : $(( OLDEST_IDX++ ))
719
720 # Only want to count it once
721 rm -f "${donep}${search_idx}"
722 touch "${skipp}${search_idx}"
723 elif [ -e "${skipp}${search_idx}" ] ; then
724 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
725 : $(( OLDEST_IDX++ ))
726 fi
f588bb03
AF
727 : $(( search_idx++ ))
728 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
f588bb03
AF
729 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
730 search_idx=${OLDEST_IDX}
731 sleep 1
732 else
733 break
734 fi
735 fi
736 done
737}
738
9ec49f8f
MF
739build_targets() {
740 for t in "$@" ; do
741 # If a LIST_xxx var exists, use it. But avoid variable
742 # expansion in the eval when a board name contains certain
743 # characters that the shell interprets.
744 case ${t} in
745 *[-+=]*) list= ;;
746 *) list=$(eval echo '${LIST_'$t'}') ;;
747 esac
748 if [ -n "${list}" ] ; then
749 build_targets ${list}
750 else
f588bb03
AF
751 : $((TOTAL_CNT += 1))
752 : $((CURRENT_CNT += 1))
753 rm -f "${donep}${TOTAL_CNT}"
754 rm -f "${skipp}${TOTAL_CNT}"
08510204
JH
755 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
756 : $((SKIP_CNT += 1))
757 touch "${donep}${TOTAL_CNT}"
758 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
759 : $((SKIP_CNT += 1))
760 touch "${donep}${TOTAL_CNT}"
b594bd6a 761 else
08510204
JH
762 if [ $BUILD_MANY == 1 ] ; then
763 build_target ${t} ${TOTAL_CNT} &
764 else
765 CUR_TGT="${t}"
766 build_target ${t} ${TOTAL_CNT}
767 CUR_TGT=''
768 fi
b594bd6a 769 fi
f588bb03
AF
770 fi
771
772 # We maintain a running count of all the builds we have done.
773 # Each finished build will have a file called ${donep}${n},
774 # where n is the index of the build. Each build
775 # we've already noted as finished will have ${skipp}${n}.
776 # We track the current index via TOTAL_CNT, and the oldest
777 # index. When we exceed the maximum number of parallel builds,
778 # We look from oldest to current for builds that have completed,
779 # and update the current count and oldest index as appropriate.
780 # If we've gone through the entire list, wait a second, and
781 # reprocess the entire list until we find a build that has
782 # completed
783 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
784 manage_builds
9ec49f8f
MF
785 fi
786 done
787}
7ebf7443
WD
788
789#-----------------------------------------------------------------------
790
f50bf50d 791kill_children() {
6bdd9f89
AB
792 local OS=$(uname -s)
793 local children=""
794 case "${OS}" in
795 "Darwin")
796 # Mac OS X is known to have BSD style ps
797 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
798 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
799 ;;
800 *)
801 # everything else tries the GNU style
802 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
803 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
804 ;;
805 esac
c97d59cb
JH
806
807 kill $children 2> /dev/null
808 wait $children 2> /dev/null
f50bf50d
AF
809
810 exit
811}
812
40a28f08 813print_stats() {
7f79c6f2 814 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
f588bb03 815
c97d59cb
JH
816 # Only count boards that completed
817 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
818
f588bb03
AF
819 rm -f ${donep}* ${skipp}*
820
821 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
033220e7 822 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
b86a475c
JH
823 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
824 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
033220e7 825 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
b86a475c
JH
826 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
827 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
c97d59cb
JH
828 else
829 # Remove the logs for any board that was interrupted
830 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
f588bb03
AF
831 fi
832
08510204 833 : $((TOTAL_CNT -= ${SKIP_CNT}))
40a28f08
PT
834 echo ""
835 echo "--------------------- SUMMARY ----------------------------"
08510204
JH
836 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
837 echo "Boards skipped: ${SKIP_CNT}"
838 fi
40a28f08
PT
839 echo "Boards compiled: ${TOTAL_CNT}"
840 if [ ${ERR_CNT} -gt 0 ] ; then
b86a475c
JH
841 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
842 fi
843 if [ ${WRN_CNT} -gt 0 ] ; then
844 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
40a28f08
PT
845 fi
846 echo "----------------------------------------------------------"
f2352877 847
f50bf50d 848 if [ $BUILD_MANY == 1 ] ; then
c97d59cb 849 kill_children
f50bf50d
AF
850 fi
851
f2352877 852 exit $RC
40a28f08 853}
7ebf7443 854
40a28f08 855#-----------------------------------------------------------------------
9ec49f8f 856
0777eafb
WD
857# Build target groups selected by options, plus any command line args
858set -- ${SELECTED} "$@"
859# run PowerPC by default
9ec49f8f 860[ $# = 0 ] && set -- powerpc
9ec49f8f 861build_targets "$@"
f588bb03 862wait